// Keywords: tree-sequence recording, tree sequence recording

initialize() {
	setSeed(2); //this leads to fixation of the beneficial allele (empirical observation from Messer)
	//at generation 163 the allele gets fixed and 
	initializeTreeSeq(simplificationRatio=INF); //do not simplify tree sequence while the model is running and it will not be simplified until the save at the end.
//This lets model run quickly since simplification is slow

	initializeMutationRate(0);
	initializeMutationType("m2", 0.5, "f", 1.0); //m2 mutation with selection coefficient 1 (strong advantageous mutation)
	m2.convertToSubstitution = F;
	initializeGenomicElementType("g1", m2, 1);
	initializeGenomicElement(g1, 0, 1e6 - 1); 
	initializeRecombinationRate(3e-10);
}
1 late() {
	sim.addSubpop("p1", 5e4); //create population p1 with 50,000 individuals
}
100 late() {
	sample(p1.genomes, 1).addNewDrawnMutation(m2, 5e5);
}
100:10000 late() {
	mut = sim.mutationsOfType(m2);
	if (mut.size() != 1)
		stop(sim.generation + ": LOST");
	else if (sum(sim.mutationFrequencies(NULL, mut)) == 1.0)
	{
		sim.treeSeqOutput("./decap.trees");
		sim.simulationFinished();
	}
}

// Part II of this recipe, which is a Python script, may be found in
// the Recipes archive downloadable at https://messerlab.org/slim/
